;===========================================================================================
; Key_2.asm  GoAsm assembler
; Clavier
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\key_2.rc
; ..\..\bin\GoAsm key_2.asm
; ..\..\bin\GoLink key_2.obj res\key_2.res user32.dll kernel32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE = 17

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr Title,\
                          WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,addr msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,addr msg

    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmkeydown
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmkeydown:
    cmp D[@uMsg],WM_KEYDOWN
    jne >.wmpaint
        cmp D[@wParam],VK_SPACE
        jne >>.exit
            ; Boite  message
            ; ---------------
            invoke MessageBox,0,addr Msg2,addr ClassName,MB_OK

            ; Demande la fin de l'application
            ; -------------------------------
            invoke PostMessage,[@hWnd],WM_DESTROY,NULL,NULL
            jmp >.exit

    .wmpaint:
    cmp D[@uMsg],WM_PAINT
    jne >.defwindowproc
        ; Dbut criture/dessin
        ; ---------------------
        invoke BeginPaint,[@hWnd],addr ps

        ; Obtenir la longueur de la chaine
        ; --------------------------------
        invoke StrLen,addr Msg1

        ; Ecriture Msg1 dans la fenetre
        ; -----------------------------
        invoke TextOut,[ps.hdc],[XChar],[YChar],addr Msg1,eax

        ; Fin criture/dessin
        ; -------------------
        invoke EndPaint,[@hWnd],addr ps
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:
    mov eax,0
    ret
endf

;===========================================================================================
; Obtenir la longueur d'une chaine
;-------------------------------------------------------------------------------------------
; @AdrStr = Adresse de la chaine
; ==> eax = longueur de la chaine
;-------------------------------------------------------------------------------------------
StrLen frame @AdrStr
    uses ecx,esi

    mov esi,[@AdrStr]
    mov ecx,0

    : 
        lodsb
        inc ecx
        or al,al
    jnz <

    dec ecx
    mov eax,ecx

    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  Title     db ' Clavier',0
  ClassName db ' AsmGges Win32',0
  MsgEnd    db ' GoAsm AsmGges France @2006  ',0
  Msg1      db ' Appuyez sur la barre espace ',0
  Msg2      db ' Vous avez appuy sur la barre espace !',0
  align 4

  WinX      dd 0
  WinY      dd 0
  WinW      dd 512
  WinH      dd 352
  XChar     dd 120
  YChar     dd 80

  hWnd      dd ?
  wc        WNDCLASS    < 0,addr WindowProc,0,0,NULL,NULL,NULL,\
                          COLOR_WINDOW+1,NULL,addr ClassName >
  ps        PAINTSTRUCT <>
  msg       MSG         <>

;===========================================================================================
